local addon_name = "USBFT"
local addon_messageId = "USBFT3"

local bar = nil
local waiter= Inspect.Time.Real()
local waittime=15
local addon_state="on"
local bloodfire_state = "on"
local unstable_state = "on"

local myzone = "<unknown>"
local myshard = "<unknown>"
local lastrecvd = "nothing"
local waitingtosend = 0
local foundzone = 0
local message = "nothing"
local ignorethis = 0
local redfont = "#FF0000"
local greenfont = "#00FF00"



local context = UI.CreateContext("usfbt_context")
	  bar = UI.CreateFrame("Frame", "Bar", context)
      bar:SetVisible(false)
      bar.solid = UI.CreateFrame("Frame", "Solid", bar)
      bar.text = UI.CreateFrame("Text", "Text", bar)
      bar.time = Inspect.Time.Real()
      bar.text:SetFontSize(30) -- was 40
      bar.text:SetFontColor(1, 0, 0, 1)
      bar.text:SetPoint("CENTER", bar.solid, "CENTER", 0, 25)
      bar.solid:SetLayer(-1)
      bar.solid:SetPoint("TOPLEFT", bar, "TOPLEFT", 0, 25)
      bar.solid:SetBackgroundColor(0, 0, 0, 0)
      bar:SetPoint("TOPCENTER", UIParent, "TOPCENTER", 0, 50)
	  Command.Console.Display("general", true, "<font color='#ffff00'>" .. "Welcome to Unstable/Bloodfire Tracker" .. "</font>", true)
	  
function updateEnd(handle)
	local nowtime = Inspect.Time.Real()
	if (nowtime >= bar.time+15) then
		bar:SetVisible(false)
		bar.time = Inspect.Time.Real()
	else
		-- do we have a message to send?
		if (waitingtosend == 1) then
			waitingtosend = 0

			local ZoneID = Inspect.Unit.Detail("player")
			local ZoneInfo = Inspect.Zone.Detail(ZoneID.zone)
			myzone = ZoneInfo.name

				foundzone = 0
					local consoles=Inspect.Console.List()
					local newShardName = Inspect.Shard().name
					for cid, flag in pairs(consoles) do
						local console=Inspect.Console.Detail(cid)
						if console.channel then
							for cname, flag in pairs(console.channel) do
								if ( (cname:sub(1, ZoneInfo.name:len()+1) == ZoneInfo.name.."@") and foundzone == 0) then
									-- we are in a "zone@server" channel
									newShardName=cname:sub(ZoneInfo.name:len()+2)
									foundzone = 1
								end
							end
						end
					end
					
					found = 0
					local mymessage = message .. ":" .. newShardName
					
					Command.Message.Broadcast("guild", nil, addon_messageId, mymessage);
					Command.Message.Broadcast("yell", nil, addon_messageId, mymessage);
					Command.Message.Broadcast("raid", nil, addon_messageId, mymessage);
					Command.Message.Broadcast("party", nil, addon_messageId, mymessage);
					
					ignorethis = 0
					if (string.find(mymessage, "Unstable") and unstable_state=="off") then
						-- ignore this message but rebroadcast
						ignorethis = 1
					end
					if (string.find(mymessage, "Bloodfire") and bloodfire_state=="off") then
						-- ignore this message but rebroadcast
						ignorethis = 1
					end	
					if (ignorethis == 0) then
						if (string.find(mymessage, "active on")) then
							Command.Console.Display("general", true, "<font color='" .. greenfont .. "'>" .. mymessage .. "</font>", true)
							if (addon_state == "on") then
								bar.text:SetFontColor(0, 1, 0, 1)
								bar.text:SetText(mymessage)
								bar:SetVisible(true)
								bar.time = Inspect.Time.Real()
							end
						else 
							Command.Console.Display("general", true, "<font color='" .. redfont .. "'>" .. mymessage .. "</font>", true)
							if (addon_state == "on") then
								bar.text:SetFontColor(1, 0, 1, 1)
								bar.text:SetText(mymessage)
								bar:SetVisible(true)
								bar.time = Inspect.Time.Real()
							end						
						end

					end
					ignorethis = 0
					lastrecvd = mymessage

			
		end	
		
	end

end

function questAccepted(handle, elements)
	for k,v in pairs(elements) do
		local qd = Inspect.Quest.Detail(k)
		if ( string.find(qd.name, "Stronghold") or string.find(qd.name, "Incursion") ) then
			-- ignore bloofire stronghold
		elseif ( string.find(qd.name, "Unstable") or string.find(qd.name, "Bloodfire") ) then
			Command.Console.Display("general", true, "<font color='#ffff00'>" .. "</font>", true)
			waitingtosend = 1
			local ZoneID = Inspect.Unit.Detail("player")
			local ZoneInfo = Inspect.Zone.Detail(ZoneID.zone)
			myzone = ZoneInfo.name			
			message = qd.name .. " active on " .. myzone
			
		end
	end
end

function questComplete(handle, elements)

	for k,v in pairs(elements) do
		local qd = Inspect.Quest.Detail(k)
		if ( string.find(qd.name, "Stronghold") or string.find(qd.name, "Incursion") ) then
			-- ignore bloofire stronghold
		elseif ( string.find(qd.name, "Unstable") or string.find(qd.name, "Bloodfire") ) then
			Command.Console.Display("general", true, "<font color='#ffff00'>" .. "</font>", true)
			waitingtosend = 1
			local ZoneID = Inspect.Unit.Detail("player")
			local ZoneInfo = Inspect.Zone.Detail(ZoneID.zone)
			myzone = ZoneInfo.name			
			message = qd.name .. " ended on " .. myzone
			
		end
	end
			
end

function messages(handle, from, messagetype, channel, id, data)
	if (id==addon_messageId) then
		-- print("lastrecvd was " .. lastrecvd)
		-- print("new data is   " .. data)
		

		
		if (Inspect.Time.Real() >= (waiter+15)) then
			if (lastrecvd == data) then
				-- same message, not displaying
				-- print ("already got this message")
			else
			
				ignorethis = 0
				if (string.find(data, "Unstable") and unstable_state=="off") then
					-- ignore this message but rebroadcast
					ignorethis = 1
				end
				if (string.find(data, "Bloodfire") and bloodfire_state=="off") then
					-- ignore this message but rebroadcast
					ignorethis = 1
				end		
				
				
					-- new message!
					-- print("messagetype was " .. messagetype)
					if (messagetype == "guild") then
						-- send to raid and party
						Command.Message.Broadcast("yell", nil, addon_messageId, data);
						Command.Message.Broadcast("raid", nil, addon_messageId, data);
						Command.Message.Broadcast("party", nil, addon_messageId, data);
					else
						-- send to guild
						Command.Message.Broadcast("guild", nil, addon_messageId, data);
					end
					if (ignorethis == 0) then
						if (string.find(data, "active on")) then
							Command.Console.Display("general", true, "<font color='" .. greenfont .. "'>" .. data .. "</font>", true)
							if (addon_state == "on") then
									bar.text:SetFontColor(0, 1, 0, 1)
									bar.text:SetText(data)
									bar:SetVisible(true)
									bar.time = Inspect.Time.Real()
									waiter = Inspect.Time.Real()
							end						
						
						else
							Command.Console.Display("general", true, "<font color='" .. greenfont .. "'>" .. data .. "</font>", true)
							if (addon_state == "on") then
									bar.text:SetFontColor(1, 0, 1, 1)
									bar.text:SetText(data)
									bar:SetVisible(true)
									bar.time = Inspect.Time.Real()
									waiter = Inspect.Time.Real()
							end						
						end
						

					end
				
				ignorethis = 0
			end
		end
		lastrecvd = data
 	end
	
end

function slash_usbft(handle, parameter)
	
	if (parameter == "") then
		print("Commandlist:")
		print("/usbft on (Announcements visible)")
		print("/usbft off (Announcements hidden)")
		print("/usbft bloodfire Toggles Bloodfire announcements")
		print("/usbft unstable Toggles Unstable announcements")
	elseif (parameter == "on") then
		print("ON: Announcements visible!")
		addon_state = "on"
	elseif (parameter == "off") then
		print("OFF: Announcements hidden!")
		addon_state = "off"
	elseif (parameter == "bloodfire") then
		if bloodfire_state == "on" then
			bloodfire_state = "off"
			print("bloodfire announcements are now off")
		else
			bloodfire_state = "on"
			print("bloodfire announcements are now on")
		end
	elseif (parameter == "unstable") then
		if unstable_state == "on" then
			unstable_state = "off"
			print("unstable announcements are now off")
		else
			unstable_state = "on"
			print("unstable announcements are now on")
		end
	else
		print("Unknown command!")
		print("Commandlist:")
		print("/usbft on (Announcements visible)")
		print("/usbft off (Announcements hidden)")
		print("/usbft bloodfire Toggles Bloodfire announcements")
		print("/usbft unstable Toggles Unstable announcements")
	end
end


local function usbft_load(handle, addon)
	addonstate = "on"
	unstablestate = "on"
	bloodfirestate = "on"
	
	if addon == addon_name then
		if addonstate then
			addon_state = addonstate
		end
		if unstablestate then
			unstable_state = unstablestate
		end
		if bloodfirestate then		
			bloodfire_state = bloodfirestate
		end
	end
end

local function usbft_save(handle, addon)
	if addon == addon_name then
			addonstate = addon_state
			unstablestate = unstable_state
			bloodfirestate = bloodfire_state
	end
end







Command.Message.Accept(nil, addon_messageId)
Command.Event.Attach(Command.Slash.Register("usbft"), slash_usbft, "USBFT")
Command.Event.Attach(Event.Message.Receive, messages, "USBFTMessages")
Command.Event.Attach(Event.System.Update.End, updateEnd, "USBFTEnd")
Command.Event.Attach(Event.Quest.Accept, questAccepted, "USBFTQuestAccepted")
Command.Event.Attach(Event.Quest.Complete, questComplete, "USBFTQuestCompleted")
Command.Event.Attach(Event.Addon.SavedVariables.Save.Begin, usbft_save, "USBFTSaveBegin")
Command.Event.Attach(Event.Addon.SavedVariables.Load.End, usbft_load, "USBFTLoadEnd")
